% Calculates bed shear stress and determines variability of bed shear
% stress within runs
% Last edit: '08-Nov-2023 09:48:15'

fclose all; clearvars; close all; clc
cd('D:\Onderzoek\2_Data-analyse\4_lab_sand-mud')
restoredefaultpath

addpath(genpath('Scripts'))

test = false;

if test
    % Select small set of experiments
    % expID = struct('name', {'S1_E2_D45_2', 'S1_E2_D80_1', 'S1_E2_D80_2', 'S1_E2_D100_1'});  % ??
%     expID = struct('name', {'Ub_S1_E2_D100_2', 'Ub_S1_E3_D80_2', 'Ub_S1_E3_D100_2'}); % Test-set 4C met inst-data
    % expID = struct('name', {'S2_E6_D30', 'S2_E6_D45_1', 'S2_E6_D45_2', 'S2_E6_D60', 'S2_E6_D80_1', 'S2_E6_D100_1', 'S2_E6_D100_2'});  % Test-set 2C 
%     expID = struct('name', {'Ub_S3_E1_D30', 'Ub_S3_E1_D45_1', 'Ub_S3_E1_D45_2', 'Ub_S3_E1_D60', 'Ub_S3_E1_D80_1', 'Ub_S3_E1_D100_2'});  % Test-set 2C met inst.data
    expID = struct('name', {'Ub_S2_E1_D80_2', 'Ub_S2_E1_D100_2', 'Ub_S2_E2_D80_2', 'Ub_S2_E2_D100_2', 'Ub_S2_E3_D80_2', 'Ub_S2_E3_D100_2', 'Ub_S2_E4_D80_2', 'Ub_S2_E4_D100_2', 'Ub_S2_E5_D80_2', 'Ub_S2_E5_D100_2', 'Ub_S2_E6_D80_2', 'Ub_S2_E6_D100_2', 'Ub_S2_E7_D100_2',...
        'Ub_S3_E1_D80_2', 'Ub_S3_E1_D100_2', 'Ub_S3_E2_D80_2', 'Ub_S3_E2_D100_2', 'Ub_S3_E3_D80_2', 'Ub_S3_E3_D100_2', 'Ub_S3_E5_D80_2', 'Ub_S3_E5_D100_2', 'Ub_S3_E6_D80_2', 'Ub_S3_E6_D100_2'});  % High discharges of S2 and S3 (S2_E7_D80_2 is missing !!)

    [expID.config_2C] = deal(true);
    for n = 1:length(expID)
        if isempty(strfind(expID(n).name, 'D80')); expID(n).Q = 100;
        else; expID(n).Q = 80; end
    end
    tmp_silt = [0,0, 0.017,0.017, 0.05,0.05, 0.1,0.1, 0.2,0.2, 0.3,0.3, 0.5,...
        0.02,0.02, 0.043,0.043, 0.09,0.09, 0.23,0.23, 0.3,0.3];
    for n = 1:length(expID)
        expID(n).silt = tmp_silt(n);
    end
    clear tmp_silt

%     [expID.config_2C] = deal(false);

else
    % Select all experiments with _2:
    expID = dir('Data\UBT\Runs\Ub_*_2');
    expID([expID.isdir] == 0) = [];     % Keep only folders in list
    rmidx = [];
    for n = 1:height(expID)
        if isempty(strfind(expID(n).name, 'Ub_')); rmidx = [rmidx,n]; end
    end
    expID(rmidx) = [];  % Remove other folders from list
    expID = rmfield(expID, {'folder', 'datenum', 'bytes', 'isdir', 'date'});

    % Sort natural order:
    expID = sort_nat({expID.name});
    expID = struct('name', expID);
    % Specify configuration (2C or 4C) of runs
    [expID.config_2C] = deal(true);
    for n = 1:length(expID)
        expID(n).config_2C = false;
        if strcmp(expID(n).name, 'Ub_S1_E3_D100_2'); break; end    % Last experiment with 4C
    end
end

% Add discharge to the list
for n = 1:length(expID)
    expID(n).Q = str2double(expID(n).name(strfind(expID(n).name, 'D')+1 : end-2));
end

% Add percentages of silt
for n = 1:length(expID)
    if ~isempty(strfind(expID(n).name, 'S1'))
        expID(n).sFine = 0;
        expID(n).sCoarse = 0;
    elseif ~isempty(strfind(expID(n).name, 'S2')) & ~isempty(strfind(expID(n).name, 'E1'))
        expID(n).sFine = 0;
        expID(n).sCoarse = 0;
    elseif ~isempty(strfind(expID(n).name, 'S2')) & ~isempty(strfind(expID(n).name, 'E2'))
        expID(n).sFine = 0;
        expID(n).sCoarse = 0.017;
    elseif ~isempty(strfind(expID(n).name, 'S2')) & ~isempty(strfind(expID(n).name, 'E3'))
        expID(n).sFine = 0;
        expID(n).sCoarse = 0.05;
    elseif ~isempty(strfind(expID(n).name, 'S2')) & ~isempty(strfind(expID(n).name, 'E4'))
        expID(n).sFine = 0;
        expID(n).sCoarse = 0.1;
    elseif ~isempty(strfind(expID(n).name, 'S2')) & ~isempty(strfind(expID(n).name, 'E5'))
        expID(n).sFine = 0;
        expID(n).sCoarse = 0.2;
    elseif ~isempty(strfind(expID(n).name, 'S2')) & ~isempty(strfind(expID(n).name, 'E6'))
        expID(n).sFine = 0;
        expID(n).sCoarse = 0.3;
    elseif ~isempty(strfind(expID(n).name, 'S2')) & ~isempty(strfind(expID(n).name, 'E7'))
        expID(n).sFine = 0;
        expID(n).sCoarse = 0.5;
    elseif ~isempty(strfind(expID(n).name, 'S3')) & ~isempty(strfind(expID(n).name, 'E1'))
        expID(n).sFine = 0.02;
        expID(n).sCoarse = 0;
    elseif ~isempty(strfind(expID(n).name, 'S3')) & ~isempty(strfind(expID(n).name, 'E2'))
        expID(n).sFine = 0.043;
        expID(n).sCoarse = 0;
    elseif ~isempty(strfind(expID(n).name, 'S3')) & ~isempty(strfind(expID(n).name, 'E3'))
        expID(n).sFine = 0.09;
        expID(n).sCoarse = 0;
    elseif ~isempty(strfind(expID(n).name, 'S3')) & ~isempty(strfind(expID(n).name, 'E5'))
        expID(n).sFine = 0.23;
        expID(n).sCoarse = 0;
    elseif ~isempty(strfind(expID(n).name, 'S3')) & ~isempty(strfind(expID(n).name, 'E6'))
        expID(n).sFine = 0.3;
        expID(n).sCoarse = 0;
    end
end

%% Read UBT data

for f = 1:length(expID)
    datadir_UBT = ['Data\UBT\runs\', expID(f).name];
    if expID(f).config_2C
        UBT{f} = f_read_UBT_2C(datadir_UBT);
    else
        UBT{f} = f_read_UBT_4C_with_stresses(datadir_UBT);
    end
end

%% Interne klok vd UBT staat verkeerd afgesteld: verschil met CEST is 2 uur

for c = 1:length(UBT)
    for i = 1:length(UBT{c})
    UBT{c}(i).ptimes = UBT{c}(i).ptimes + 2/24;
    end
end

%% Make some plots

close all
n = 15;      % expID
m = 1;      % config

figure, hold on
row = round(rand([4,1])*size(UBT{n}(m).V1_proc,1));
for i = 1:4
    subplot(2,2,i), hold on
    plot(UBT{n}(m).U_proc(row(i),:), -UBT{n}(m).pdist, 'LineWidth', 2, 'Marker', 'o')

    plot(UBT{n}(m).V1_proc(row(i),:), -UBT{n}(m).pdist)
    plot(UBT{n}(m).V2_proc(row(i),:), -UBT{n}(m).pdist)

    xl = xlim(gca);
    [~, acmax] = max(UBT{n}(m).A1_proc(row(i),:));
    plot([xl(1), xl(2)], -[UBT{n}(m).pdist(acmax), UBT{n}(m).pdist(acmax)], 'k')

    legend('U_s', 'V_1', 'V_2', 'Bed position')
    grid on

    title(datestr(UBT{n}(m).ptimes(row(i)), 'HH:MM:SS'))

    set(gca, 'ylim', [-UBT{n}(m).pdist(acmax)-0.01, 0])
    box on
end    

set(gcf, 'Color', 'white')
set(gcf, 'Position', get(0, 'ScreenSize'))
%%
%% Calculate bed shear stress
%% Select time windows and save them to expID
m=1;
for n = 1:length(expID)
    expID(n).wstart = [];
    expID(n).wstop = [];
end

UBT2 = UBT;

expID(12).wstart = UBT2{12}(m).ptimes(1);
expID(12).wstop = datenum('24-May-2022 09:59');

expID(18).wstart = UBT2{18}(m).ptimes(1);
expID(18).wstop = datenum('07-Jun-2022 15:45');

expID(21).wstart = UBT2{21}(m).ptimes(1);
expID(21).wstop = datenum('9-Jun-2022 15:55');

expID(27).wstart = UBT2{27}(m).ptimes(1);
expID(27).wstop = datenum('16-Jun-2022 15:48');

expID(33).wstart = datenum('4-Aug-2022 07:57');
expID(33).wstop = UBT2{33}(m).ptimes(end);

expID(34).wstart = UBT2{34}(m).ptimes(1);
expID(34).wstop = datenum('5-Aug-2022 09:51');

expID(39).wstart = UBT2{39}(m).ptimes(1);
expID(39).wstop = datenum('15-Aug-2022 16:48');

expID(42).wstart = datenum('19-Aug-2022 16:46');
expID(42).wstop = UBT2{42}(m).ptimes(end);

expID(45).wstart = UBT2{45}(m).ptimes(1);
expID(45).wstop = datenum('24-Aug-2022 16:51');

% Save tabel number to expID. Only used in plot title and to specify the order of the sub-plots:
[expID.num] = deal(0);
[expID.num] = [16	17	18	13	14	15	11	12	8	9	1	2	3	19	20	21	22	23	24	25	26	27	28	29	30	31	32	33	34	36	37	38	39	40	41	42	43	44	45	46	47	48	49	50	51]; % See list in "labsheet.xlsx"

%% Step 1: determine height of bedform tops

% Discrepancy in field names: "U" in 4C-config is the same as "U_proc" in 2C-config
idx4C = find([expID.config_2C] == 0);
for n = 1:length(idx4C)
    UBT2{idx4C(n)}(1).U_proc = UBT2{idx4C(n)}(1).U;
    UBT2{idx4C(n)}(2).U_proc = UBT2{idx4C(n)}(1).U;
    UBT2{idx4C(n)}(1).W_proc = UBT2{idx4C(n)}(1).W;
    UBT2{idx4C(n)}(2).W_proc = UBT2{idx4C(n)}(1).W;
end
clear idx4C

for n = 1:length(UBT2)
    % First recalculate bed position
    UBT{n}(m).bed_pos = NaN(1, length(UBT2{n}(m).ptimes));    % Remove constant bed position. We want this to vary as dunes are moving over the bed
    [~, UBT2{n}(m).bed_idx] = max(mean(cat(3,UBT{n}(m).A1_proc, UBT{n}(m).A2_proc),3), [], 2);      % Maximum amplitude based on mean of 2 beams
    UBT2{n}(m).bed_pos = -UBT2{n}(m).pdist(UBT2{n}(m).bed_idx);

    %Remove data below bed level:
    for t = 1:length(UBT2{n}(m).ptimes)
        UBT2{n}(m).A1_proc(t,UBT2{n}(m).bed_idx(t)+1:end) = NaN;
        UBT2{n}(m).A2_proc(t,UBT2{n}(m).bed_idx(t)+1:end) = NaN;
        UBT2{n}(m).V1_proc(t,UBT2{n}(m).bed_idx(t)+1:end) = NaN;
        UBT2{n}(m).V2_proc(t,UBT2{n}(m).bed_idx(t)+1:end) = NaN;
        UBT2{n}(m).U_proc(t,UBT2{n}(m).bed_idx(t)+1:end) = NaN;
        UBT2{n}(m).W_proc(t,UBT2{n}(m).bed_idx(t)+1:end) = NaN;        
    end

    % Cut based on time window:
    if ~isempty(expID(n).wstart)
        tidx = findnearest(expID(n).wstart, UBT{n}(m).ptimes) : findnearest(expID(n).wstop, UBT{n}(m).ptimes);
    else
        tidx = 1:length(UBT2{n}(m).ptimes);     % No window provided, so use all data
    end

    % Find highest bed level (95 percentile - To avoid outliers)
    UBT2{n}(m).bed_top = prctile(UBT2{n}(m).bed_pos(tidx), 95);

    % Calculate sigma with sigma=0 at the position of the (95% highest) dune top (within time window if provided):
    UBT2{n}(m).sig(1,:) = (UBT2{n}(m).pdist + UBT2{n}(m).bed_top)./UBT2{n}(m).bed_top;
    UBT2{n}(m).sig(find(UBT2{n}(m).sig<0)) = NaN;   % Remove values below bed
    UBT2{n}(m).sig(find(UBT2{n}(m).sig == 0)) = 0.001;  % Change sig=0 by sig = 0.001 to prevent log(0) later on

end

%% Step 2: Find u* through linear model fit:
close all
PLOT = 0;
PLOTprofiles = 1;
vonkarman = 0.41;

% Define sigma windows (vertical windows) for sensitivity test:
sigWin = [0.15, 0.6;...
    0.175, 0.625;...
    0.2, 0.65;...
    0.225, 0.675;...
    0.25, 0.7;...
    0.25, 0.725;...
    0.25, 0.75;...
    0.2, 0.75;...
    0.225, 0.75;...
    0.275, 0.775;...
    0.3, 0.8];

[~, nsort] = sort([expID.num]);

% for n = 1:length(UBT2)
for nf = 1:length(nsort)
    n = nsort(nf);
    % Average velocity within time window:
    if ~isempty(expID(n).wstart)
        tidx = findnearest(expID(n).wstart, UBT{n}(m).ptimes) : findnearest(expID(n).wstop, UBT{n}(m).ptimes);
    else
        tidx = 1:length(UBT2{n}(m).ptimes);
    end
    UBT2{n}(m).U_proc_mean = mean(UBT2{n}(m).U_proc(tidx,:), 1, 'omitnan');     % Averaging Uinst gives the same result, except very close to the bottom

    % Loop over sigma windows; store only R^2 and Mannings n
    for s = 2%1:size(sigWin,1)

        % Define height of fit (depending on sigma-window):
        fitidx = find(UBT2{n}(m).sig >= sigWin(s,1) & UBT2{n}(m).sig <= sigWin(s,2));
    
        % Fit logarithmic profile:
        fmod = fitlm(UBT2{n}(m).U_proc_mean(fitidx), log(UBT2{n}(m).sig(fitidx))+1);
        UBT2{n}(m).fmod.A = fmod.Coefficients.Estimate(2);             % Slope (u*/kappa)
        UBT2{n}(m).fmod.A_SE = fmod.Coefficients.SE(2);
        UBT2{n}(m).fmod.B = fmod.Coefficients.Estimate(1);             % Intercept (U)
        UBT2{n}(m).fmod.B_SE = fmod.Coefficients.SE(1);
        UBT2{n}(m).fmod.Rsq = fmod.Rsquared.Ordinary;

        R2(n,s) = fmod.Rsquared.Ordinary;
    
        clear fmod
    
        if PLOT
           figure, hold on
           subplot(3,1,1), hold on
            plot(UBT2{n}(m).ptimes, UBT2{n}(m).bed_pos, 'LineWidth', 1.5);
                datetick('x', 'keeplimits'); grid on; box on
            plot(get(gca, 'xlim'), [UBT2{n}(m).bed_top, UBT2{n}(m).bed_top], 'k');      % Line indicating sigma=0
            plot([UBT2{n}(m).ptimes(tidx(1)), UBT2{n}(m).ptimes(tidx(1))], get(gca, 'ylim'), 'k--');    %n Start of time window
            plot([UBT2{n}(m).ptimes(tidx(end)), UBT2{n}(m).ptimes(tidx(end))], get(gca, 'ylim'), 'k--'); % End of time window
            title(num2str(n))
    
           subplot(3,1,[2,3]); hold on
            for t = 1:length(tidx)
                plot(UBT2{n}(m).U_proc(tidx(t),:), UBT2{n}(m).sig, 'Color', [0.9,0.9,0.9])
            end
            plot(UBT2{n}(m).U_proc_mean, UBT2{n}(m).sig, 'k', 'LineWidth',1.5)
            plot(UBT2{n}(m).U_proc_mean(fitidx), UBT2{n}(m).sig(fitidx), 'r', 'LineWidth',2)
            set(gca, 'YScale', 'log')
            grid on; box on
            set(gcf, 'Color', 'white')
        end

        if PLOTprofiles
            figure(100); hold on
            subplot(5,9,nf); hold on
            for t = 1:length(tidx)
                plot(UBT2{n}(m).U_proc(tidx(t),:), UBT2{n}(m).sig, 'Color', [0.9,0.9,0.9])
            end
            plot(UBT2{n}(m).U_proc_mean, UBT2{n}(m).sig, 'k', 'LineWidth',1.5)
            plot(UBT2{n}(m).U_proc_mean(fitidx), UBT2{n}(m).sig(fitidx), 'r', 'LineWidth',2)
            set(gca, 'ylim', [0.1,1])
            set(gca, 'YScale', 'log')
            grid on; box on
            set(gcf, 'Color', 'white')
%             title(strrep(strrep(strrep(expID(n).name, 'Ub_', ''), '_2', ''), '_', '-'), 'FontSize', 13)
            title(num2str(expID(n).num), 'FontSize', 13)

            if rem(nf-1,9) == 0
                ylabel('ln(\sigma)', 'FontSize', 12)
            end
            if nf > 36
                xlabel('u (m/s)', 'FontSize', 12)
            end
        end
        
        % Calculate u* and t_b
        UBT2{n}(m).u_fric = UBT2{n}(m).fmod.A*vonkarman;   % u_* = slope * kappa
        UBT2{n}(m).tb = 1000 * UBT2{n}(m).u_fric.^2;  % tau_bed = rho * u_*^2 (Pa)
    
        % Calculate z_0 and k_s
        UBT2{n}(m).z0 = (-UBT2{n}(m).bed_top + 0.05) ./ exp(vonkarman.*UBT2{n}(m).fmod.B ./ UBT2{n}(m).u_fric +1); % z_0 = (h + eta) / e^(kappa*U/u* + 1) ==> 0.05 = distance waterlevel - transducer
        ks{n} = 30.*UBT2{n}(m).z0;
    
        % Mannings roughness coefficient:
        mann{n} = ks{n}.^(1/6)./25;

        % Manning for all sigma-windows:
        n_manning(n,s) = ks{n}.^(1/6)./25;
    end

end

figure(100); set(gcf, 'Position', get(0, 'ScreenSize'))
set(gcf, 'Color', 'white')
print(gcf, 'All_log-profiles-v2', '-dpng', '-r350')
savefig(gcf, 'Figures\All_log-profiles-v2', 'compact')

R2_av = mean(R2,1);
[best,best_idx] = max(R2_av);

%%
% figure, hold on
for n = 1:length(expID)
    if ~isempty(strfind(expID(n).name, 'S1'))
        plot(n, mann{n}, 'o', 'MarkerFaceColor', [0.5020    0.6941    0.8275], 'MarkerEdgeColor', 'k', 'MarkerSize', round(([expID(n).sCoarse] + [expID(n).sFine])*70)+5)
    elseif ~isempty(strfind(expID(n).name, 'S2'))
        plot(n, mann{n}, 'o', 'MarkerFaceColor', [0.9922    0.7059    0.3843], 'MarkerEdgeColor', 'k',  'MarkerSize', round(([expID(n).sCoarse] + [expID(n).sFine])*70)+5)
    elseif ~isempty(strfind(expID(n).name, 'S3'))
        plot(n, mann{n}, 'o', 'MarkerFaceColor', [0.7020    0.8706    0.4118], 'MarkerEdgeColor', 'k',  'MarkerSize', round(([expID(n).sCoarse] + [expID(n).sFine])*70)+5)
    end
end
% l=legend(expID.name); set(l, 'Location', 'eastoutside');
xlabel('Experiment #'); ylabel('Manning roughness coefficient')
box on; grid on
set(gcf, 'Color', 'white')

%% Plot roughness as function of silt content
figure, hold on
scatter([expID.sCoarse] + [expID.sFine], [mann{:}], 20, 'filled')
xlabel('Silt content (coarse + fine)'); ylabel('Manning roughness coefficient')
box on; grid on
set(gcf, 'Color', 'white')


% %% Bed shear stress is super high
% %% Sjoukjes z_0 is okay. Calculate z_0 as a check
% 
% % eq. 14 in Hoitink 2009:
% % z_0 = (h + eta) / e^(kappa*U/u* + 1)
% % with:
% % kappa = 0.41
% % U = intercept from previous fit (UBT2{n}.fmod.B
% % u* = u_fric
% 
% 
% % From Sjoukje:
% g=9.81;
% for n = 1:length(UBT2)
%     ks{n} = 30.*UBT2{n}(m).z0;
%     mann{n} = ks{n}.^(1/6)./25;
%      tmp = -UBT2{n}(m).bed_pos;     % To prevent complex numbers. Why is this necessary?
%     fri{n} = (mann{n}./(tmp .^ (1/6))).^2 *g;
%     C{n} = sqrt((8*g)./fri{n});
% end










