%data to read and preporcess line laser scanner output
%sjoukje.delange@wur.nl
% 2022 04 01

% %replace comma by dot in files
% Data = fileread(FileName);
% Data = strrep(Data, ',', '.');
% FID = fopen(NewFileName, 'w');
% fwrite(FID, Data, 'char');
% fclose(FID);


%% load data
clc; clear all
% Exp = 'S2_E2_D100';
Exp = 'test1';

% file = strcat('C:\Users\lange184\OneDrive - WageningenUR\Voorbereiding-lab_Gedeelde-map\Data\LineLaser\Line_', Exp, '.dat');
% file = strcat('W:\PROJECTS\Deltas_out_of_Shape\projects\Lab_sjoukje\Data\LineLaser\Line_', Exp, '.dat');

file = ('C:\Users\lange184\Downloads\flume_test.dat');
% file = ('C:\Users\lange184\Downloads\flume_test_2.0.dat')

line = readtable (file, 'NumHeaderLines', 10);
header =  {'Time', 'Xpos', 'Ypos', 'Zpos', 'sensorID', 'results'};

%if normal file
if size(line,2) > 4
    line = renamevars(line, ["Var1", "Var2", "Var3", "Var4", "Var5", "Var6"], header);
    line(1:2:end,:) = [];

%if weird version
else
    %read data
    fid = fopen(file);
    formatspec = ['%D%f%f%f%s', repmat('%f', 1, 309)];
    c  = textscan(fid, formatspec, 'headerLines', 10);
    fclose (fid);
    
    clear line;

    line=table; %make empty table
    
    %fill table
    for i = 1:length(c)
    line{:,i} =  (c{i});
    end

    %rename variables
    line = renamevars(line, ["Var1", "Var2", "Var3", "Var4", "Var5", "Var6"], header);

    %delete every second row
    line(1:2:end,:) = [];
    clear formatspec c header t fid i
end

%% preprocess data
%the file is structured as follows
% each line is a measurement
% the first 6 colums are metadata
% column 7 to 160 are the y-values
% column 161 to 314 are the z-values
% in total there are 154 measurement points

meas  = line.results(2); %measruement points
startmeas = 7; %start of measurement points in line file

%delete measurement errors (value is zero)
line{:,7:end}(line{:,7:end}==0) = NaN; %set zero to NaN


cd ('W:\PROJECTS\Deltas_out_of_Shape\projects\Lab_sjoukje\Data\LineLaser\matlabdata')
%% assign x, y,z value to each point
xmat = zeros (size(line,1), meas); %zero matrix for x
y_posstrok = zeros(size(line,1), meas); %zero matrix for stroke position

for i = 1:size(line,1)
x_mat(i,:) = xmat(i,:) + line.Xpos(i); %matrix x
y_strok(i,:) = line.Ypos(i) - y_posstrok(i,:); %matrix stroke position

    for n = 1:meas
%         y_mat(i,n) = line.Ypos(i) + line{i, [n-1+startmeas]}; %matrix 
        y_mat(i,n) = line{i, [n-1+startmeas]} - line.Ypos(i) ; %matrix 
        
    end
end
z_mat = line{:, meas+startmeas:end}; %matrix z
clear xmat y_posstrok

%make columns from each matrix
x = x_mat(:);
y = y_mat(:);
z = z_mat(:);
ystrok = y_strok(:);

% cd 'C:\Users\lange184\OneDrive - WageningenUR\Voorbereiding-lab_Gedeelde-map\Data\LineLaser\matlabdata'
% cd ('W:\PROJECTS\Deltas_out_of_Shape\projects\Lab_sjoukje\Data\LineLaser\matlabdata')
cd ('C:\Users\lange184\Downloads\')

save(strcat('scan_', Exp, '.mat'),'x', 'y', 'z')

m = [x, y, z] ;
m = m(~isnan(m(:,3)),:);
writematrix(m,strcat('scan_', Exp, '.csv') )


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%








%% visualize
% figure; hold on,
% scatter(x,y,[],z, 'filled'); axis equal
% h = colorbar; ylabel (h, 'bed level (mm)')
% xlabel ('longitudonal direction (mm)'); ylabel ('width (mm)');
% caxis ([40 150])
% title (Exp)
% 
% saveas(gcf,strcat('scan_', Exp, '.fig'))
% close all

%% strokes
% strokpos = [200 500 800]; %position of strokes
% 
% clear idx
% 
% for i = 1:length(strokpos)
% idx(:,i) = find (ystrok == strokpos(i));
% end
% 
% figure; 
% for i = 1:length(strokpos)
% subplot(4,1,5-i)
% scatter(x(idx(:,i)), y(idx(:,i)), [], z(idx(:,i)), 'filled')
% title (num2str(strokpos(i)))
% axis equal
% end
% 
% 
% % %% surface plot
% %delete nans
% x1 = x(~isnan(y));
% z1 = z(~isnan(y));
% y1 = y(~isnan(y));
% 
% % interpolate to regular grid
% dx = 5; dy = dx;
% xvec = min(x1):dx:max(x1);
% yvec = min(y1):dy:max(y1);

% %make mesh
% [X,Y] = meshgrid(xvec,yvec);
% ZInt = scatteredInterpolant(x1,y1, z1, 'natural', 'none');
% Z = ZInt(X,Y);
% % 
% %plot surface
% colormap jet
% figure;
% % surface(X,Y,Z, Z, 'EdgeColor','none')
% surf(X,Y,Z, Z, 'EdgeColor','none')
% colorbar; 
% % axis equal;
% view(0, 20)

% mapshow(X, Y, Z, 'DisplayType', 'surface')

% %hillshade plot
% %with function from https://nl.mathworks.com/matlabcentral/fileexchange/14863-hillshade?s_tid=mwa_osa_a
% addpath ('M:\PhDSjoukje\Data_analysis\hillshade')
% h = hillshade([Z], xvec,  yvec);
% figure; imagesc(xvec, yvec, h); axis equal


% %% profiles in longidudonal direction
% %make transects
% xprof{1}(1,:) = min(x);
% xprof{1}(2,:) = max(x);
% xprof{2} = xprof{1};
% xprof{3} = xprof{1};
% xprof{4} = xprof{1};
% xprof{5} = xprof{1};
% 
% yprof{1}(1,:) = -650;
% yprof{1}(2,:) = -650;
% yprof{2}(1,:) = -450;
% yprof{2}(2,:) = -450;
% yprof{3}(1,:) = -250;
% yprof{3}(2,:) = -250;
% yprof{4}(1,:) = -50;
% yprof{4}(2,:) = -50;
% yprof{5}(1,:) = 150;
% yprof{5}(2,:) = 150;
% 
% % %check transects
% col = {'r', 'k', 'g', 'y', 'c'};
% % figure; hold on,
% % scatter(x,y,[],z, 'filled'); axis equal
% % h = colorbar; ylabel (h, 'bed level (mm)')
% % xlabel ('longitudonal direction (mm)'); ylabel ('width (mm)');
% % for i = 1:length(yprof)
% %     plot(xprof{i}, yprof{i}, 'Color', col{i});
% % end
% 
% %make profiles
% dx = 2; % step size in profile 2 mm
% for i =1:length(yprof)
%     profiles{i} = grid2transect(x,y,z, xprof{i}, yprof{i}, 'dstep', dx); 
% end
% 
% 
% figure; hold on
% for i = 1:length(profiles)
% plot(profiles{i}.x, profiles{i}.z, 'Color', col{i});
% end
% xlabel ('longitudonal direction (mm)'); ylabel ('bed level (mm)');
% 
% 
% %save profiles
% cd ('W:\PROJECTS\Deltas_out_of_Shape\projects\Lab_sjoukje\Data\LineLaser\matlabdata\profiles')
% save(strcat('profiles_', Exp, '.mat'),'profiles')
% close all
% 
% % %% figure of profiles
% % cd 'C:\Users\lange184\OneDrive - WageningenUR\Voorbereiding-lab_Gedeelde-map\Data\LineLaser\matlabdata\profiles'
% % col = [107, 174, 214; 99, 99, 99; 0, 109, 44]/255;
% % figure; 
% % subplot (1,2,1), hold on,
% % load ('profiles_S3_E2_D45.mat')
% % for i =1:length(profiles)
% % plot (profiles{i}.d/1000, profiles{i}.z/10, 'Color', col(i,:))
% % end
% % legend ('left', 'middle', 'right')
% % title ('45 L/s')
% % ylim ([3 18])
% % ylabel ('bed level (cm)'); xlabel ('longitudonal distance (m)')
% % 
% % subplot (1,2,2), hold on,
% % load ('profiles_S1_E5_D80.mat')
% % for i =1:length(profiles)
% % plot (profiles{i}.d/1000, profiles{i}.z/10, 'Color', col(i,:))
% % end
% % title ('80 L/s')
% % ylim ([3 18])
% % xlabel ('longitudonal distance (m)')
